import csv
import re
import chardet
import requests
from bs4 import BeautifulSoup

book_links = []
book_info_list = []
book_info = {'书名': '', '作者': '', '类型': '', '标签': '', '签约状态': '', '完结状态': '',
             '字数': '', '收藏': '', '霸王票': '', '营养液': '', '书评': ''}

# 定义爬取的网页地址
url = "https://m.jjwxc.net/rank"
# 发送GET请求获取网页内容
response = requests.get(url)
# 使用chardet检测网页编码
encoding = chardet.detect(response.content)['encoding']
response.encoding = encoding
# 使用BeautifulSoup解析网页HTML
soup = BeautifulSoup(response.text, 'html.parser')
# 使用正则表达式提取链接
pattern = r'<a class="channellink" href="([^"]*)">([^<]*)</a>'
links = re.findall(pattern, response.text)

#
for link in links:
    link = "https://m.jjwxc.net" + link[0]
    response = requests.get(link)
    # 使用chardet检测网页编码
    encoding = chardet.detect(response.content)['encoding']
    response.encoding = encoding
    soup = BeautifulSoup(response.text, 'html.parser')
    # 找到所有榜单的书籍链接
    divs = soup.find_all('div', class_='halfcol')
    for div in divs:
        ul = div.find('ul')
        if ul:
            for li in ul.find_all('li'):  # 遍历 <ul> 中的 <li> 标签
                a = li.find('a')  # 找到 <li> 中的 <a> 标签
                if a:
                    link = a['href']  # 获取 <a> 标签的 href 属性值
                    if not link.startswith('/wapauthor'):  # 检查链接是否以 '/wapauthor' 开头
                        link = "https://m.jjwxc.net" + link
                        book_links.append(link)  # 将拼接后的链接添加到列表中
                        # print(book_links[-1])  # 输出拼接后的链接值（最后添加到列表中的那个）
                        # 从链接中获取书籍名称，使用html.unescape进行解码

                        book_name = a.text.replace('\xa0', ' ')  # 空格替换为正常空格，保持格式一致性
                        # print(f"书名：{book_name}")
                        # 创建一个新的字典，并填充数据
                        book_info = book_info.copy()  # 浅拷贝字典
                        book_info['书名'] = book_name
                        book_info_list.append(book_info)  # 添加新的字典到列表中

                        response = requests.get(link)
                        # 使用chardet检测网页编码
                        encoding = chardet.detect(response.content)['encoding']
                        response.encoding = encoding

                        soup = BeautifulSoup(response.text, 'html.parser')
                        divs = soup.find_all('div', class_='b module')

                        for div in divs:
                            author_name_element = div.find('li', class_='authorname-content')
                            if author_name_element is not None:
                                author_name = author_name_element.text.replace('\xa0', ' ').replace('作者：', '')
                                author_name = author_name.replace('\n', '')
                                # print(f"作者：{author_name}")
                                book_info['作者'] = author_name
                            lis = div.find_all('li')
                            result_dict = {}  # 创建一个空字典来存储结果
                            for li in lis:
                                # print(li)
                                type_text = li.get_text()
                                # print(type_text)
                                lines = type_text.split('\n')  # 将文本按行分割
                                for line in lines:
                                    if line.startswith("类型："):  # 如果行以"类型："开头
                                        type_ = line.replace("类型：", "").strip()  # 获取类型
                                        # print(f"类型: {type_}")
                                        book_info['类型'] = type_
                                    elif line.startswith("标签："):  # 如果行以"标签："开头
                                        tags = line.replace("标签：", "").strip()  # 获取标签
                                        # print(f"标签: {tags}")
                                        book_info['标签'] = tags
                                    elif line.startswith("状态："):  # 如果行以"状态："开头
                                        status_all = line.replace("状态：", "").strip()  # 获取状态
                                        parts = status_all.split('/')
                                        signing = parts[0]
                                        book_info['签约状态'] = signing
                                        serialisation = parts[1]
                                        book_info['完结状态'] = serialisation
                                        characters = parts[2].replace("字","").strip()
                                        book_info['字数'] = characters
                                for l in li.find_all('a'):  # 先找到所有的<a>标签
                                    text = l.text.strip()  # 提取链接文本
                                    if text:  # 排除空元素
                                        # 输出元素文本
                                        # print(text)
                                        if "收藏" in text:
                                            collection = text.replace("收藏(", "").replace(")", "").strip()
                                            # print(f"收藏：{collection}")
                                            book_info['收藏'] = collection
                                        elif "霸王票" in text:
                                            num = text.replace("霸王票(№", "").replace(")", "").strip()
                                            # print(f"霸王票：{num}")
                                            book_info['霸王票'] = num
                                        elif "营养液" in text:
                                            num = text.replace("灌溉营养液(", "").replace(")", "").strip()
                                            # print(f"营养液：{num}")
                                            book_info['营养液'] = num
                                        elif "书评" in text:
                                            num = text.replace("看书评(", "").replace(")", "").strip()
                                            # print(f"书评：{num}")
                                            # print('\n')
                                            book_info['书评'] = num
                                        else:
                                            num = None  # 其他情况，设定数字为None，你可以根据需要修改这部分逻辑

    # 定义CSV文件的字段名（与每本书的属性对应）
    fields = ["书名", "作者", "类型", "标签", "签约状态", "完结状态", "字数", "收藏",
              "霸王票", "营养液", "书评"]

    # 创建并写入CSV文件
    with open('all_books_1080.csv', mode='w', newline='', encoding='utf-8') as csv_file:
        writer = csv.DictWriter(csv_file, fieldnames=fields)
        writer.writeheader()  # 写入字段名作为表头
        for book in book_info_list:  # 遍历每本书的属性信息并写入CSV文件
            writer.writerow(book)  # 将每本书的属性信息写入CSV文件作为一行数据