import csv


def extract_info(filename):
    with open(filename, 'r', encoding='utf-8') as f:
        reader = csv.reader(f)
        next(reader)
        label_info = []  # 创建一个空列表来保存类型信息
        # 遍历csv文件的每一行
        for row in reader:  # 遍历每一行
            # 获取第三列的内容，通常为标签信息
            types = row[3]
            # 使用字符串的split方法分割类型信息中的各个部分
            parts = types.split(' ')
            for part in parts:
                label_info.append(part)  # 将新行添加到列表中
        return label_info  # 返回类型信息列表

def write_to_csv(filename, label_info):  # 创建一个新的函数来写入数据到csv文件
    with open('label.csv', 'w', newline='', encoding='utf-8') as csv_file:  # 打开输出文件
        fields = ['标签']
        writer = csv.DictWriter(csv_file, fieldnames=fields)
        writer.writeheader()  # 写入字段名作为表头
        for type_info in label_info:  # 将字典写入到输出文件中
            writer.writerow({'标签': type_info})

        # 调用函数，输入你的csv文件路径，这里使用了一个示例路径：D:\\晋江数据采集\\books_01.csv


label_info = extract_info('D:\\晋江数据采集\\all_books.csv')  # 读取数据并获取类型信息列表
write_to_csv('label.csv', label_info)  # 将类型信息写入到新的csv文件中