import csv
from collections import Counter


def count_words_in_csv(file_path):
    with open(file_path, 'r', encoding='utf-8') as f:
        reader = csv.reader(f)
        data = [row for row in reader]  # 读取所有行到一个列表中
    words = [row[0] for row in data]
    # 使用Counter函数统计词语出现的次数
    word_counts = Counter(words)
    return word_counts


def write_to_csv(file_path, word_counts):
    # 将字典写入CSV文件
    with open(file_path, mode='w', newline='', encoding='utf-8') as csv_file:
        fields = ['词语', '次数']
        writer = csv.DictWriter(csv_file, fieldnames=fields)  # 使用csv.DictWriter
        writer.writeheader()  # 写入表头
        for word, count in word_counts.items():
            writer.writerow({'词语': word, '次数': count})  # 将每个单词及其出现次数写入CSV文件作为一行数据


# 统计词语出现次数并保存到新的CSV文件
word_counts = count_words_in_csv('label.csv')
write_to_csv('label_statistics.csv', word_counts)