import csv
from collections import defaultdict, Counter

# 打开文件并读取数据
with open('types.csv', 'r', encoding='utf-8') as f:
    reader = csv.DictReader(f)
    data = [row for row in reader]

# 使用 defaultdict 来初始化 field_counts，这样当不存在的键被访问时，会自动创建一个默认值字典
from collections import defaultdict

field_counts = defaultdict(dict)

# 提取每个字段中的字符串，并统计种类和数量
for row in data:
    for field in ['原创与否', 'CP类型', '年代背景', '小说主题', '视角']:
        value = row[field]
        # 使用 defaultdict 的特性，不存在的键会自动创建默认值字典，这里默认值是 0
        field_counts[field][value] = field_counts[field].get(value, 0) + 1

    # 输出结果并将其保存到新的CSV文件
with open('statistics.csv', 'w', encoding='utf-8', newline='') as f:
    writer = csv.DictWriter(f, fieldnames=['Field', 'Value', 'Count'])
    writer.writeheader()
    for field, counts in field_counts.items():
        for count in counts:
            writer.writerow({'Field': field, 'Value': count, 'Count': counts[count]})